package edu.smcvt.util;

import java.util.*;
import java.util.concurrent.*;

public class ThreadSet<E> extends LinkedHashSet<E>{
   private Semaphore sem;
	private String name;
      
	public ThreadSet(){
		super();
		sem = new Semaphore(1,true);
		name = "";
	}  
	public void setName(String s){ name = s; }
	public String getName(){ return name; }
        
   public void getLock(String grabber){
		boolean acquired = false; 
		//System.out.println("Trying to acquire " + name + " for " + grabber);
      while(!acquired){ 
  			try{ 
     	        sem.acquire();
              acquired = true;
    		} catch(InterruptedException e) {}
      }
		//System.out.println("Acquired " + name + " for " + grabber);
	}
		
	public void releaseLock(String slipper){
		//System.out.println("Trying to release " + name + " for " + slipper); 
		sem.release();
		//System.out.println("Released " + name + " for " + slipper);	
	}
}